clear all
close all


global ind   % indicator function of active set 
global n1    % discretisation in time, variable j
global n2    % discretisation in space, variable i
global Tmax  % temperature constraint


n1=100;
n2=10;
lambda=0.1;
umax=1;
Tmax=1.5;




% Initializing

x0=[zeros(1,4*n1+4),5];
y=fsolve(@f1,x0);

x0=[y,zeros(1,(n1+1)*(n2+1))];
y=fsolve(@f2,x0);

%x0=[y,zeros(1,(n1+1)*(n2+1))];
%y=fsolve(@f3,x0);

% state unconstrained solution obtained here


y=[y,zeros(1,(n1+1)*(n2+1))];

% solving full problem with PDAS


options=optimset('MaxIter', 5 , 'Display' , 'iter'); 

for t=1:10  % number of active set steps


if t==1
    
% initial active set 

for j=1:(n1+1)
    for i=1:(n2+1)
        if y(4*n1+5+(i-1)*(n1+1)+j)-Tmax<=0                  
           ind(i,j)=0; 
        else
           ind(i,j)=1; 
        end    
    end    
end


x0=[y(1:4*n1+4), y(4*n1+6:4*n1+5+2*(n1+1)*(n2+1)),zeros(1,(n1+1)*(n2+1)),y(4*n1+5)];

else
    
for j=1:(n1+1)
    for i=1:(n2+1)
        if y(4*n1+4+2*(n1+1)*(n2+1)+(i-1)*(n1+1)+j)+y(4*n1+4+(i-1)*(n1+1)+j)-Tmax<=0  
           ind(i,j)=0; 
        else
           ind(i,j)=1; 
        end    
    end    
end   
    


x0=y;

end

t



y=fsolve(@f,x0,options);

end




% Reconstruction of variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



for j=1:(n1+1)
    w1(j) = y(j);
    w2(j) = y(n1+1+j);
    p1(j) = y(2*n1+2+j);
    p2(j) = y(3*n1+3+j);
    u(j)  = max(min(umax, -1/lambda*p2(j)),-umax);    
    for i=1:(n2+1)
        T(i,j) = y(4*n1+4+(i-1)*(n1+1)+j);
        q(i,j) = y(4*n1+4+(n1+1)*(n2+1)+(i-1)*(n1+1)+j);
        mu(i,j) = y(4*n1+4+2*(n1+1)*(n2+1)+(i-1)*(n1+1)+j);
    end
end 

tf = y(4*n1+4+3*(n1+1)*(n2+1)+1);





% Plots
%%%%%%%%



[Ort,Zeit] = meshgrid(linspace(0,1,(n2+1)),linspace(0,tf,(n1+1)));

figure('name', 'w1')
plot(linspace(0,tf,size(w1,2)),w1)
title('w1')

figure('name', 'w2')
plot(linspace(0,tf,size(w2,2)),w2)
title('w2')

figure('name', 'p1')
plot(linspace(0,tf,size(p1,2)),p1)
title('p1')

figure('name', 'p2')
plot(linspace(0,tf,size(p2,2)),p2)
title('p2')

for j=1:size(u,2)          
    linie2(j)=-1;
    linie3(j)=1;
    linie4(j)=0;
end
 figure('name', 'u')
 plot(linspace(0,tf,size(u,2)),u)
 hold on
 plot(linspace(0,tf,size(u,2)),linie2,':')
 plot(linspace(0,tf,size(u,2)),linie3,':')
 plot(linspace(0,tf,size(u,2)),linie4,':')
 hold off
 title('u')

 figure('name', 'T')
 surf(Ort',Zeit',T)
 colormap jet(1024)
 title('T')
 
 figure('name', 'q')
 surf(Ort',Zeit',q)
 colormap jet(1024)
 title('q')
 
 
 figure('name', 'mu')
 surf(Ort',Zeit',mu)
 colormap jet(1024)
 title('\mu')
 
 figure('name', 'active set')
 surf(Ort',Zeit',ind)
 colormap jet(1024)
 title('active set')
 
 
 
 