clear all
close all



global n1    
global n2
global n3
global Tmax  % temperature constraint
global k 
global alpha 
global umax  % control constraint
global N     % Number of nodes for k and alpha 


lambda=0.1;
umax=1;
Tmax=1.5;
N=30;

for n=1:N
options=optimset('Display','off','TolFun',0.00000001);
k(n) = fsolve(@myfun,(n-1)*pi,options);
end
k(1)=1.306542374;

for n=1:N    
 alpha(n)=1/(0.5*k(n)^2+1.5)*(sin(k(n))+1/k(n)*(1-cos(k(n))))*(k(n)*cos(0.5*k(n))+sin(0.5*k(n)));
end





% Computation of state unconstrained solution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

n1=117; % Discretisation in time and space for f1 and f2
n2=10;

x0=[zeros(1,4*n1+4),5];
y=fsolve(@f1,x0);

x0=[y,zeros(1,(n1+1)*(n2+1))];
y=fsolve(@f2,x0);



for j=1:(n1+1)
    w1(j) = y(j);
    w2(j) = y(n1+1+j);
    p2(j) = y(3*n1+3+j);
    for i=1:(n2+1)
        T(i,j) = y(4*n1+5+(i-1)*(n1+1)+j);       
    end    
end


p1 = y(2*n1+2+5);
tf = y(4*n1+5); 

a=abs(T(ceil((n2+1)/2),:)-Tmax);

ton=find(min(a(1:ceil((n1+1)/2)))==a)/(n1+1)*tf;
toff=find(min(a(ceil((n1+1)/2:n1+1)))==a)/(n1+1)*tf;

% state unconstrained solution obtained here



n1=40; % discretizations of the 3 sections 
n2=40; % it must hold n1+n2+n3 = (old) n1+3!!!
n3=40;




x0=[w1';w2';p1;p2';1;ones(n2,1);ton;toff;tf;1];  % initial guesses provided by state unconstrained solution
options=optimset('Display','iter','MaxFunEvals',200000);
y=fsolve(@findirect2,x0,options);





% Reconstruction of variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


for j=1:n1
    w1a(j) = y(j);  
    w2a(j) = y(j+n1+n2+n3-2);
    p2a(j) = y(j+2*n1+2*n2+2*n3-3);   
 end 
 
 for j=1:n2
    w1b(j) = y(j+n1-1);
    w2b(j) = y(j+2*n1+n2+n3-3);
    p2b(j) = y(j+3*n1+2*n2+2*n3-4);
    p3b(j) = y(j+3*n1+3*n2+3*n3-4);
 end
 
 for j=1:n3
    w1c(j) = y(j+n1+n2-2);
    w2c(j) = y(j+2*n1+2*n2+n3-4);
    p2c(j) = y(j+3*n1+3*n2+2*n3-5);
 end   
 

 
    p1     = y(2*n1+2*n2+2*n3-3);  
    
    p3a    = y(3*n1+3*n2+3*n3-4);  
    
    
    ton    = y(3*n1+4*n2+3*n3-3);
    toff   = y(3*n1+4*n2+3*n3-2);
    tf     = y(3*n1+4*n2+3*n3-1);
    mu     = y(3*n1+4*n2+3*n3);


    
    
 % A posteriori computation of w3
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
 
 for t=1:n1 
    int(t)=0;
    
    for s=1:t
       if s==1
          int(t)=int(t)+0.5*w2a(s)^2*sum(alpha.*exp(-k.^2*(t-s)/((n1)-1)*ton));
         elseif s==t  
          int(t)=int(t)+0.5*w2a(s)^2*sum(alpha.*exp(-k.^2*(t-s)/((n1)-1)*ton));
         else
          int(t)=int(t)+w2a(s)^2*sum(alpha.*exp(-k.^2*(t-s)/((n1)-1)*ton));
         end  
    end  
    w3a(t)=int(t)/(n1-1)*ton;    
 end

 
 for j=1:n2
    int3(j)=0; % 1. Integral for w3b=Tmax 
    for s=1:n1
        if s==1
           int3(j)=int3(j)+0.5*sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n2-1)*(toff-ton)+ton-(s-1)/(n1-1)*ton)));
        elseif s==n1
           int3(j)=int3(j)+0.5*sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n2-1)*(toff-ton)+ton-(s-1)/(n1-1)*ton)));
        else
           int3(j)=int3(j)+sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n2-1)*(toff-ton)+ton-(s-1)/(n1-1)*ton))); 
        end   
    end
    int3(j)=int3(j)/(n1-1)*ton;
 end
 
 int4(1)=0;
 for j=2:n2
     int4(j)=0;  % 2. Integral for w3b=Tmax
     for s=1:j
         if s==1
             int4(j)=int4(j)+0.5*sum(alpha.*w2b(s).^2.*exp(-k.^2*(j-s)/(n2-1)*(toff-ton)));
         elseif s==j
             int4(j)=int4(j)+0.5*sum(alpha.*w2b(s).^2.*exp(-k.^2*(j-s)/(n2-1)*(toff-ton)));  
         else    
             int4(j)=int4(j)+sum(alpha.*w2b(s).^2.*exp(-k.^2*(j-s)/(n2-1)*(toff-ton)));
         end    
     end 
     int4(j)=int4(j)/(n2-1)*(toff-ton);
 end    
 
 
 w3b=int3+int4;
 
 
 for j=1:n3
    int6(j)=0; % 1. Integral for w3c 
    for s=1:n1
        if s==1
           int6(j)=int6(j)+0.5*sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n3-1)*(tf-toff)+toff-(s-1)/(n1-1)*ton)));
        elseif s==n1
           int6(j)=int6(j)+0.5*sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n3-1)*(tf-toff)+toff-(s-1)/(n1-1)*ton)));
        else
           int6(j)=int6(j)+sum(alpha.*w2a(s).^2.*exp(-k.^2*((j-1)/(n3-1)*(tf-toff)+toff-(s-1)/(n1-1)*ton))); 
        end   
    end
    int6(j)=int6(j)/(n1-1)*ton;
 end
 
 for j=1:n3
     int7(j)=0;  % 2. Integral for w3c
     for s=1:n2
         if s==1
             int7(j)=int7(j)+0.5*sum(alpha.*w2b(s).^2.*exp(-k.^2*((j-1)/(n3-1)*(tf-toff)+toff-(s-1)/(n2-1)*(toff-ton)-ton)));
         elseif s==n2
             int7(j)=int7(j)+0.5*sum(alpha.*w2b(s).^2.*exp(-k.^2*((j-1)/(n3-1)*(tf-toff)+toff-(s-1)/(n2-1)*(toff-ton)-ton))); 
         else    
             int7(j)=int7(j)+sum(alpha.*w2b(s).^2.*exp(-k.^2*((j-1)/(n3-1)*(tf-toff)+toff-(s-1)/(n2-1)*(toff-ton)-ton)));
         end    
     end 
     int7(j)=int7(j)/(n2-1)*(toff-ton);
 end   
 
 int8(1)=0;
 for j=2:n3
     int8(j)=0;  % 3. Integral for w3c
     for s=1:j
         if s==1
             int8(j)=int8(j)+0.5*sum(alpha.*w2c(s).^2.*exp(-k.^2*(j-s)/(n3-1)*(tf-toff)));
         elseif s==j
             int8(j)=int8(j)+0.5*sum(alpha.*w2c(s).^2.*exp(-k.^2*(j-s)/(n3-1)*(tf-toff))); 
         else    
             int8(j)=int8(j)+sum(alpha.*w2c(s).^2.*exp(-k.^2*(j-s)/(n3-1)*(tf-toff)));
         end    
     end 
     int8(j)=int8(j)/(n3-1)*(tf-toff);
 end   
 
 
 w3c=int6+int7+int8;
 
 
 
 
 % Plots
 %%%%%%%%
 
 figure
 plot(linspace(0,ton,n1),w1a);
 hold on
 plot(linspace(ton,toff,n2),w1b);
 plot(linspace(toff,tf,n3),w1c);
 hold off
 title('w1')
 
 figure
 plot(linspace(0,ton,n1),w2a);
 hold on
 plot(linspace(ton,toff,n2),w2b);
 plot(linspace(toff,tf,n3),w2c);
 hold off
 title('w2')
 
 
 figure
 plot(linspace(0,ton,n1),w3a);
 hold on
 plot(linspace(ton,toff,n2),w3b);
 plot(linspace(toff,tf,n3),w3c);
 hold off
 title('w3')
 
 figure
 plot(linspace(0,ton,n1),p2a);
 hold on
 plot(linspace(ton,toff,n2),p2b);
 plot(linspace(toff,tf,n3),p2c);
 hold off
 title('p2')
 
 figure
 plot(linspace(0,ton,n1),p3a);
 hold on
 plot(linspace(ton,toff,n2),p3b);
 plot(linspace(toff,tf,n3),0);
 hold off
 title('p3')
 
 

    
